#!/usr/local/bin/perl

$ver = "v1.06e";
#| slime-breeder Version 1.06(2000/02/17)
#| by tatuta(1999/6/29beta-1999/11/22v1.00)
#| tatuta@geocities.co.jp
#| HomePageUrl(Japanese) http://www2j.biglobe.ne.jp/~tatuta/_MENU.htm
#|
#| adapted for use in an English environment by rika (baratie@west.net)

# ----------------------------------------------------------
# Initial Settings
# ----------------------------------------------------------

$backurl   = 'http://www.you.com/~yourpage/';		# URL of page to go back afterwards
$backtitle = 'TITLE';								# What to call above URL
													# you can add more similarly (backurl2/backtitle2 and the like)

$comtmax = 50;										# max number of oneliner comments stored
$rankmax = 50;										# max number of ranked slimes stored
$dendo   = 3;										# number of champion defences before hall of fame

$ps_god = 'dna';									# password for DNA analysis 
$ps_usr = 'user';									# password to look at user files
$ps_mna = 'system';									# password to enter system analysis page
													# enter these passwords in God's Realm.

$cginame     = './slme.cgi';						# name of this file
$userfile    = './slmuser.cgi';					# storage of user information
$rankfile    = './slmrank.cgi';					# slime ranking storage
$kingfile    = './slmking.cgi';					# hall of fame storage
$comtfile    = './slmcomt.cgi';					# comments
$usertmp     = './slmuser.tmp';					# user temp file
$ranktmp     = './slmrank.tmp';					# ranking temp file
$kingtmp     = './slmking.tmp';					# hall of fame temp file
$comttmp     = './slmcomt.tmp';					# comment temp file
$userloc     = './slmuser.loc';					# user lock file
$rankloc     = './slmrank.loc';					# ranking lock file
$kingloc     = './slmking.loc';					# hall of fame lock file
$comtloc     = './slmcomt.loc';					# comment lock file

$bg_gif       = './slmbg.gif';						# background
$char_normal  = "./slmnormal.gif";
$char_aura    = "./slmaura.gif";
$char_hider   = "./slmhider.gif";
$char_wing    = "./slmwing.gif";
$char_ribbon  = "./slmribbon.gif";
$char_ribbonw = "./slmribbonw.gif";
$char_crown   = "./slmcrown.gif";
$char_crownw  = "./slmcrownw.gif";
$char_angel   = "./slmangel.gif";
$char_devil   = "./slmdevil.gif";
$char_aho     = "./slmaho.gif";
$char_oyaji   = "./slmoyaji.gif";
$char_musi    = "./slmmusi.gif";
$char_zombie  = "./slmzombie.gif";

# ----------------------------------------------------------
# Initial Global Variables
# ----------------------------------------------------------

$seed_gage = $rankmax * 10;							# Speed of seed creation
$henka = 50;								# Mutation rate (1/$henka)

$eve =<<"_EOF_";
0<p><p>Eve<p><p>LordCreator<p><p>#ffffff<p>$char_normal<p><p>48<>60<s>51<>58<s>32<>51<s>40<>48<s>54<>49<s>45<>37<s>62<>41<s>1<s>1<s>1<s>1<s>1<s>1<s>1<s>1<s>1<m>45<>40<s>60<>41<s>63<>52<s>50<>49<s>48<>39<s>63<>63<s>61<>42<s>1<s>1<s>1<s>1<s>1<s>1<s>1<s>1<s>1<p><>LordCreator<><s><>LordCreator<><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><p><p><p>d
_EOF_

$adam =<<"_EOF_";
1<p>0<p>Adam<p><p>LordCreator<p><p>#000000<p>./slmnormal.gif<p><p>43<>63<s>64<>29<s>63<>47<s>54<>53<s>36<>62<s>41<>61<s>47<>44<s>0<s>0<s>0<s>0<s>0<s>0<s>0<s>0<s>0<m>52<>50<s>53<>42<s>52<>55<s>47<>62<s>50<>65<s>47<>60<s>49<>61<s>0<s>0<s>0<s>0<s>0<s>0<s>0<s>0<s>0<p><>LordCreator<><s><>LordCreator<><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><s><><><p>10<p>0<p>0<>0<p>0<p>d
_EOF_

# ----------------------------------------------------------
# Initial Settings (changes unnecessary)
# ----------------------------------------------------------

&read_form;
srand (time ^ ($$ + ($$ << 15)));
@rank = &read ($rankfile);
unless (@rank) {
	$cain = &create_char ($eve,$adam);
	($u_no,$u1,$u_name,$u3,$u4,$u5,$u6,$u7,$u_status,$u9,$ua,$ub,$check,$ud) = split(/<p>/,$cain);
	$cain = "2<p>1<p>Cain<p>$u3<p>Eve<p>$u5<p>$u6<p>$u7<p>$u_status<p>$u9<p>$ua<p>10<p>0<p>1<>0<p>0<p>1\n";

	$abel = &create_char ($eve,$adam);
	($u_no,$u1,$u_name,$u3,$u4,$u5,$u6,$u7,$u_status,$u9,$ua,$ub,$check,$ud) = split(/<p>/,$abel);
	$abel = "1<p>2<p>Abel<p>$u3<p>Eve<p>$u5<p>$u6<p>$u7<p>$u_status<p>$u9<p>$ua<p>10<p>0<p>0<>1<p>0<p>2\n";

	push (@rank,$cain);
	push (@rank,$abel);
	&save ($rankfile,$ranktmp,$rankloc,@rank);
}
&wgt_set;

# ----------------------------------------------------------
# HTML
# ----------------------------------------------------------

$html_head=<<"_EOF_";
Content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=$charset_code">
<TITLE>Slime Breeder</TITLE>
</HEAD>
<BODY BGCOLOR="#000000" TEXT="#eeeeee" LINK="#00FFFF" VLINK="#7FFFFF">
<BASEFONT SIZE=3 FACE="Lucida Casual">
_EOF_

$html_foot=<<"_EOF_";
<HR>
<!-- Copyright notice (must stay intact, no abbreviations allowed) -->
<DIV ALIGN="right">
<FONT color="#7f7fff" FACE="Times New Roman"><i><B>SLIME BREEDER</B> $ver </FONT>Copyright &copy;1999 <A HREF="http://www2j.biglobe.ne.jp/~tatuta/_MENU.htm" target="_top">tatuta.</A><br>
Translated for use in an English environment by <a href="http://www.apricot.com/~fuu/" target="_top">rika</a>.</i><BR> </DIV>

</BODY></HTML>
_EOF_

# ----------------------------------------------------------
# Main
# ----------------------------------------------------------

if ($FORM{'mode'} eq 'title') { &title_print; exit; }
if ($FORM{'mode'} eq 'rank') { &rank_print; exit; }
if ($FORM{'mode'} eq 'enter') { &enter_print; exit; }
if ($FORM{'mode'} eq 'create') { &create; exit; }
if ($FORM{'mode'} eq 'fight') { &fight; exit; }
if ($FORM{'mode'} eq 'com') { &add_comt; &title_print; exit; }
if ($FORM{'mode'} eq 'king') { &king_print; exit; }
if ($FORM{'mode'} eq 'god') {
	if ($FORM{'pass'} eq $ps_god) { &rank_print; exit; }
	if ($FORM{'pass'} eq $ps_usr) { &userfile; exit; }
	if ($FORM{'pass'} eq $ps_mna) { &mania; exit; }
	&king_print; exit;
}
if ($FORM{'mode'} eq 'guide') { &guide; exit; }
if ($FORM{'mode'} eq 'mania') { &mania; exit; }
&frame_set;
exit;

# ----------------------------------------------------------
# Frames
# ----------------------------------------------------------

sub frame_set{
	print "Content-type: text/html\n\n";
	print <<"_EOF_";
<HTML>
<HEAD>
<TITLE>Slime Breeder</TITLE>
</HEAD>

<FRAMESET ROWS="240,*">
	<FRAME SRC="$cginame?mode=title" NAME="top">
	<FRAME SRC="$cginame?mode=rank" NAME="bottom">
</FRAMESET>

<NOFRAMES>
<BODY BGCOLOR="#003f3f" TEXT="#eeeeee" LINK="#00FFFF" VLINK="#7FFFFF">
<CENTER>
<font size=5>You must be able to use frames to play this.  Sorry.</font>
</BODY>
</NOFRAMES>
</HTML>
_EOF_
}

# ----------------------------------------------------------
# Determine Average Weight
# ----------------------------------------------------------

sub wgt_set {
	$wgt_sum = 0;
	foreach $line (@rank) {
		$status = (split(/<p>/,$line))[8];
		$wgt_sum += (split (/<>/,$status))[0];
	}
	$wgt_ave = int ($wgt_sum / @rank);
	$disp_cut = length($wgt_ave) - 2;
	$tumble = 8;
	$range = int ($wgt_ave / 30) + 2;
}

# ----------------------------------------------------------
# Title Screen
# ----------------------------------------------------------

sub title_print {
	&get_cookie;
	if ($c_name eq '') {
		$comtname = "<INPUT type=\"text\" name=\"user\" size=16 value=\"Name\">";
	} else {
		$comtname = "$c_name<INPUT TYPE=\"hidden\" NAME=\"user\" VALUE=\"$c_name\">";
	}
	print $html_head;
	print<<"_EOF_";
<FORM ACTION="$cginame" METHOD=post>
<A HREF="$backurl" target="_top">$backtitle</A> / <A HREF="$cginame?mode=guide" target="bottom">Instructions</A> / <A HREF="$cginame?mode=rank" target="bottom">Ranking</A> / <A HREF="$cginame?mode=king" target="bottom">Hall of Fame</A> / <A HREF="$cginame?mode=title">Reload</A><BR>
<TABLE BORDER=0 width="100%" background="$bg_gif">
<TR><TD>
<CENTER>
<FONT size=7 color="#7f7fff" FACE="Times New Roman"><i>SLIME BREEDER</i></FONT><BR>
<BR>
<INPUT TYPE="hidden" NAME="mode" VALUE="enter">
Username:<INPUT type="text" name="user" size=16 value="$c_name">
Password:<input type="password" name="pass" size=8 maxlength=8 value="$c_pwd">
<INPUT TYPE="submit" VALUE="Enter">
</CENTER>
</FORM>
<FORM ACTION="$cginame" METHOD=post>
<small>
If this is your first time, you will register to play with the information you enter above.  Since I can't be responsible for any stolen passwords, don't use important passwords such as your e-mail 
password.<BR>
</small>
</TD></TR>
</TABLE>
<HR>
<INPUT TYPE="hidden" NAME="mode" VALUE="com">
One-liner comments: $comtname<INPUT type="text" name="comt" size=60>
<INPUT TYPE="submit" VALUE="Say It!">(must be less than 300 characters)
<HR>
_EOF_

	@comt = &read ($comtfile);
	foreach $line (@comt) {
		($date,$name,$comt,$dmy) = split(/<>/,$line);

$comt_date = "<FONT COLOR=\"#ffb0ff\">$date</FONT>";						# Date
$comt_name = "<FONT COLOR=\"#b0ffff\"><B>$name</B></FONT>";					# Name
$comt_text = "<B>($comt)</B>";							# Comment

		print "$comt_date $comt_name$comt_text<HR>\n";
	}	
	print<<"_EOF_";
</FORM>
<FORM ACTION="$cginame" METHOD="post" target="bottom">
<DIV align="right">
<INPUT TYPE="hidden" NAME="mode" VALUE="god">
God's Realm<INPUT TYPE="password" NAME="pass" SIZE=8>
<INPUT TYPE="submit" VALUE="Behold!">
</DIV>
</FORM>

_EOF_
	print $html_foot;
}

sub add_comt {
	@comt = &read ($comtfile,$comtloc);
	$date = &date(time);
	$name = $FORM{'user'};
	$comt = $FORM{'comt'};
	$ipad = $ENV{'REMOTE_ADDR'};
	$checktext = (split(/<>/,$comt[0]))[2];
	$checkname = (split(/<>/,$comt[0]))[1];

	if ($comt eq '') {
		&error(1,'Say something, will ya?');
	}
	if ($comt eq $checktext && $name eq $checkname) {
		&error(1,'You already said that.');
	}
	if (length($comt) > 300) { $comt = substr($comt,0,300); }
	if (length($name) > 16) { $name = substr($name,0,16); }

	$i = 0;
	@new = '';
	unshift(@comt,"$date<>$name<>$comt<>$ipad\n");
	foreach $line (@comt) {
		if ($i < $comtmax) { push(@new,$line); }
		$i++;
	}
	&save ($comtfile,$comttmp,$comtloc,@new);
}

# ----------------------------------------------------------
# Rankings Screen
# ----------------------------------------------------------

sub rank_print {
	print $html_head;
	print "<FONT SIZE=5 COLOR=yellow>Ranking</FONT><BR><BR>\n";

	$rank = 1;
	foreach $line (@rank) {
		$pts = (split(/<p>/,$line))[0];
		$no = (split(/<p>/,$line))[1];
		$name = (split(/<p>/,$line))[2];
		$sedai = (split(/<p>/,$line))[3];
		$color = (split(/<p>/,$line))[6];
		$seed = (split(/<p>/,$line))[11];
		if ($seed != 0) { $seed = "<FONT COLOR=\"yellow\">$seed</FONT>"; }
		$child = (split(/<p>/,$line))[12];
		$result = (split(/<p>/,$line))[13];
		$highrank = (split(/<p>/,$line))[15];
		($win,$lose) = split(/<>/,$result);
		print "<a name=\"$no\"></A>\n";
		print "<big><B>Rank $rank <FONT COLOR=\"\#ffb0ff\">$name</B></FONT><sub>$sedai</sub></big> / $seed seeds left / $child children / $win - $lose / Highest rank: $highrank / $pts<small>pts.</small><BR>\n";
		if ($FORM{'mode'} eq 'god') {
			$print = &god_print ($line);
		} else { $print = &status_print ($line); }
		print $print;
		print "<HR>\n\n";
		$rank++;
	}

	print<<"_EOF_";
<CENTER>
[<A HREF="$backurl" target="_top">$backtitle</A>][<A HREF="$cginame?mode=title" target="top">Title</A>][<A HREF="$cginame?mode=rank">Reload</A>]<BR>
</CENTER>
_EOF_

	print $html_foot;
}

sub status_print {
	local ($data) = $_[0];
	$name = (split (/<p>/,$data))[2];
	$sedai = (split (/<p>/,$data))[3];
	$owner = (split (/<p>/,$data))[4];
	$time = (split (/<p>/,$data))[5];
	$birth = &date ($time);
	$color = (split (/<p>/,$data))[6];
	$gif = (split (/<p>/,$data))[7];
	$status = (split (/<p>/,$data))[8];
	@status = split (/<>/,$status);

	$i = 0;
	$yuko = 4 - (length ($status[0]) - $disp_cut);
	foreach $line (@status) {
		$statusp[$i] = int ($status[$i] / (10 ** $disp_cut) + 0.5);
		if ($FORM{'mode'} eq 'king' && (length ($status[0]) - $disp_cut) < 1) {
			$statusp[$i] = $status[$i] / (10 ** $disp_cut);
			$statusp[$i] = substr ($statusp[$i],0,$yuko);
		}
		$i++;
	}
# 0= WGT / 1= HP / 2= STM 3= STR / 4= DEX / 5= SPD / 6= CST / 7= SEX 
	$blood = (split (/<p>/,$data))[10];
	@blood = split (/<s>/,$blood);
	
# 0= Own parent / 1= Other Parent / 2= Own Grandparent / 345= Other Grandparent
# 6= Own Great-grandparent / 7-13= Other Great-grandparent 
	for ($i = 0; $i < 14; $i++) {
		($b_no[$i],$b_name1[$i],$b_sedai[$i]) = split (/<>/,$blood[$i]);
		$b_name[$i] = "<FONT COLOR=\"#00ffff\">$b_name1[$i]</FONT>";
		if ($FORM{'mode'} eq 'rank') {
			$b_name[$i] = "<A href=\"\#$b_no[$i]\">$b_name1[$i]</A>";
		}
		if ($FORM{'mode'} eq 'create' || $FORM{'mode'} eq 'enter') {
			$b_name[$i] = "<A href=\"$cginame?mode=rank\#$b_no[$i]\" target=\"bottom\">$b_name1[$i]</A>";
		}
	}
	$gif_size = int (($status[0] / $wgt_ave * .55 + .5) * 110);

$html_status=<<"_EOF_";
<TABLE BORDER=1 BGCOLOR="#003f3f" bordercolordark="lightblue">
<TR><TD align="center" valign="middle">
	<TABLE BORDER=0 bgcolor="$color" cellpadding=0 cellspacing=0>
	<TR><TD><IMG SRC="$gif" width=$gif_size height=$gif_size></TD></TR>
	</TABLE>
	<FONT SIZE=2>weight:$status[0]</FONT><BR>
	</TD>
	<TD background="$bg_gif">
	<TABLE BORDER=1>
	<TR><TH>generation $sedai : born $birth</TH><TH>HP</TH><TH>STM</TH><TH>STR</TH><TH>DEX</TH><TH>SPD</TH></TR>
	<TR><TH>Owner: $owner</TH><TH>$statusp[1]</TH><TH>$statusp[2]</TH><TH>$statusp[3]</TH><TH>$statusp[4]</TH><TH>$statusp[5]</TH></TR>
	</TABLE>
	<TABLE BORDER=1>
	<TR><TD valign="middle">
		$b_name[0]<FONT COLOR="yellow"><sub>$b_sedai[0]</sub></FONT><BR>
		<HR>
		$b_name[1]<sub>$b_sedai[1]</sub><BR>
		</TD>
	<TD valign="middle">
		<FONT SIZE=2>$b_name[2] <FONT COLOR="yellow">$b_sedai[2]</FONT></FONT><BR>
		<FONT SIZE=2>$b_name[3] $b_sedai[3]</FONT><BR>
		<HR>
		<FONT SIZE=2>$b_name[4] $b_sedai[4]</FONT><BR>
		<FONT SIZE=2>$b_name[5] $b_sedai[5]</FONT><BR>
		</TD>
	<TD valign="top">
		<FONT SIZE=2>$b_name[6] <FONT COLOR="yellow">$b_sedai[6]</FONT></FONT><BR>
		<FONT SIZE=2>$b_name[7] $b_sedai[7]</FONT><BR>
		<FONT SIZE=2>$b_name[8] $b_sedai[8]</FONT><BR>
		<FONT SIZE=2>$b_name[9] $b_sedai[9]</FONT><BR>
		</TD>
	<TD valign="bottom">
		<FONT SIZE=2>$b_name[10] $b_sedai[10]</FONT><BR>
		<FONT SIZE=2>$b_name[11] $b_sedai[11]</FONT><BR>
		<FONT SIZE=2>$b_name[12] $b_sedai[12]</FONT><BR>
		<FONT SIZE=2>$b_name[13] $b_sedai[13]</FONT><BR>
		</TD>
	</TR>
	</TABLE>
	</TD>
</TR>
</TABLE>

_EOF_
	return $html_status;
}

# Hall of Fame

sub king_print {
	@king = &read ($kingfile);
	$bg_gif = './slmbg2.gif';
	print $html_head;
	print "<FONT SIZE=6 color=\"#7f7fff\" FACE=\"Lucida Casual\">Hall of Fame</FONT><BR><BR>\n";
	foreach $line (@king) {
		$no = (split(/<p>/,$line))[1];
		$name = (split(/<p>/,$line))[2];
		$sedai = (split(/<p>/,$line))[3];
		$color = (split(/<p>/,$line))[6];
		$child = (split(/<p>/,$line))[12];
		$result = (split(/<p>/,$line))[13];
		($win,$lose) = split(/<>/,$result);
		$lose--;
		$highrank = (split(/<p>/,$line))[15];
		($v5_rank,$v5_defend) = split(/<sup>/,$highrank);
		($defend,$dmy) = split(/</,$v5_defend);
		unless ($defend) { $defend = 0; }
		print "<big><B><FONT COLOR=\"\#dfcf3f\">$name</B><sub>$sedai</sub></big> / $win - $lose / Defended title $defend times / $child children / slime number $no to be born into this realm</FONT><BR>\n";
		$print = &status_print ($line);
		print $print;
		print "<HR>\n\n";
	}

	print<<"_EOF_";
<CENTER>
[<A HREF="$backurl" target="_top">$backtitle</A>][<A HREF="$cginame?mode=rank">Ranking</A>]<BR>
</CENTER>
_EOF_

	print $html_foot;
}

# DNA Analysis Subroutine

sub god_print {
	local ($data) = $_[0];
	$name = (split (/<p>/,$data))[2];
	$sedai = (split (/<p>/,$data))[3];
	$owner = (split (/<p>/,$data))[4];
	$time = (split (/<p>/,$data))[5];
	$birth = &date ($time);
	$color = (split (/<p>/,$data))[6];
	$gif = (split (/<p>/,$data))[7];
	$status = (split (/<p>/,$data))[8];
	@status = split (/<>/,$status);
# 0=WGT 1=HP 2=STM 3=STR 4=DEX 5=SPD 6=CST 7=SEX 
	$dna = (split (/<p>/,$data))[9];
	@dna = split (/<m>/,$dna);
	for ($i = 0; $i < 2; $i++) {
		($hrd[$i],$sft[$i],$brn[$i],$net[$i],$fat[$i],$men[$i],$sex[$i],$r[$i],$g[$i],$b[$i],$x[$i],$y[$i],$z[$i],$u[$i],$v[$i],$w[$i])  = split (/<s>/,$dna[$i]);
	}
	$blood = (split (/<p>/,$data))[10];
	@blood = split (/<s>/,$blood);
# 0= Own parent / 1= Other Parent / 2= Own Grandparent / 345= Other Grandparents
# 6= Own Great-grandparent / 7-13= Other Great-grandparents
	for ($i = 0; $i < 14; $i++) {
		($b_no[$i],$b_name1[$i],$b_sedai[$i]) = split (/<>/,$blood[$i]);
		$b_name[$i] = "<A href=\"\#$b_no[$i]\">$b_name1[$i]</A>";
	}
	$gif_size = int (($status[0] / $wgt_ave * .55 + .5) * 110);

$html_status=<<"_EOF_";
<TABLE BORDER=1 BGCOLOR="#003f3f" bordercolordark="lightblue">
<TR><TD align="center" valign="middle">
	<TABLE BORDER=0 bgcolor="$color" cellpadding=0 cellspacing=0>
	<TR><TD><IMG SRC="$gif" width=$gif_size height=$gif_size></TD></TR>
	</TABLE>
	<FONT SIZE=2>$color</FONT><BR>
	<FONT SIZE=2>weight:$status[0]</FONT><BR>
	<TABLE BORDER=1 BGCOLOR="#000000">
	<TR><TH>X</TH><TH>Y</TH><TH>Z</TH><TH>RBN</TH><TH>CRW</TH><TH>WNG</TH></TR>
	<TR><TH>$x[0]</TH><TH>$y[0]</TH><TH>$z[0]</TH><TH>$u[0]</TH><TH>$v[0]</TH><TH>$w[0]</TH></TR>
	<TR><TH>$x[1]</TH><TH>$y[1]</TH><TH>$z[1]</TH><TH>$u[1]</TH><TH>$v[1]</TH><TH>$w[1]</TH></TR>
	</TABLE>
	</TD>
	<TD BGCOLOR="#000000">
	<TABLE BORDER=1>
	<TR><TH>generation $sedai : born  $birth</TH><TH>HP</TH><TH>STM</TH><TH>STR</TH><TH>DEX</TH><TH>SPD</TH><TH>CST</TH><TH>SEX</TH></TR>
	<TR><TH>Owner: $owner</TH><TH>$status[1]</TH><TH>$status[2]</TH><TH>$status[3]</TH><TH>$status[4]</TH><TH>$status[5]</TH><TH>$status[6]</TH><TH>$status[7]</TH></TR>
	</TABLE>
	<TABLE BORDER=1>
	<TR><TH>HRD</TH><TH>SFT</TH><TH>BRN</TH><TH>NET</TH><TH>FAT</TH><TH>MEN</TH><TH>SEX</TH></TR>
	<TR><TH>$hrd[0]</TH><TH>$sft[0]</TH><TH>$brn[0]</TH><TH>$net[0]</TH><TH>$fat[0]</TH><TH>$men[0]</TH><TH>$sex[0]</TH></TR>
	<TR><TH>$hrd[1]</TH><TH>$sft[1]</TH><TH>$brn[1]</TH><TH>$net[1]</TH><TH>$fat[1]</TH><TH>$men[1]</TH><TH>$sex[1]</TH></TR>
	</TABLE>
	<TABLE BORDER=1>
	<TR><TD valign="middle">
		$b_name[0]<FONT COLOR="yellow"><sub>$b_sedai[0]</sub></FONT><BR>
		<HR>
		$b_name[1]<sub>$b_sedai[1]</sub><BR>
		</TD>
	<TD valign="middle">
		<FONT SIZE=2>$b_name[2] <FONT COLOR="yellow">$b_sedai[2]</FONT></FONT><BR>
		<FONT SIZE=2>$b_name[3] $b_sedai[3]</FONT><BR>
		<HR>
		<FONT SIZE=2>$b_name[4] $b_sedai[4]</FONT><BR>
		<FONT SIZE=2>$b_name[5] $b_sedai[5]</FONT><BR>
		</TD>
	<TD valign="top">
		<FONT SIZE=2>$b_name[6] <FONT COLOR="yellow">$b_sedai[6]</FONT></FONT><BR>
		<FONT SIZE=2>$b_name[7] $b_sedai[7]</FONT><BR>
		<FONT SIZE=2>$b_name[8] $b_sedai[8]</FONT><BR>
		<FONT SIZE=2>$b_name[9] $b_sedai[9]</FONT><BR>
		</TD>
	<TD valign="bottom">
		<FONT SIZE=2>$b_name[10] $b_sedai[10]</FONT><BR>
		<FONT SIZE=2>$b_name[11] $b_sedai[11]</FONT><BR>
		<FONT SIZE=2>$b_name[12] $b_sedai[12]</FONT><BR>
		<FONT SIZE=2>$b_name[13] $b_sedai[13]</FONT><BR>
		</TD>
	</TR>
	</TABLE>
	</TD>
</TR>
</TABLE>

_EOF_
	return $html_status;
}


# User File Subroutine

sub userfile {
	@user = &read ($userfile);
	$usersuu = @user;
	$rnd_range = ($tumble * $range - $tumble) / 2;
	print $html_head;
	print "<B>User File</B><BR>\n";
	print "Number of Users: $usersuu / Average Weight: $wgt_ave / $tumble dice with $range faces / deviation of $rnd_range<BR><BR>\n";
	foreach $line (@user) {
		$no = (split(/<p>/,$line))[0];
		$ip = (split(/<p>/,$line))[1];
		$name = (split(/<p>/,$line))[2];
		$sedai = (split(/<p>/,$line))[3];
		$owner = (split (/<p>/,$line))[4];
		$time = (split (/<p>/,$line))[5];
		$birth = &date ($time);
		$color = (split(/<p>/,$line))[6];
		$gif = (split (/<p>/,$line))[7];
		$status = (split (/<p>/,$line))[8];
		@status = split (/<>/,$status);
		$i = 0;
		foreach $line (@status) {
			$statusp[$i] = int ($status[$i] / (10 ** $disp_cut) + 0.5);
			$i++;
		}
# 0=WGT 1=HP 2=STM 3=STR 4=DEX 5=SPD 6=CST 7=SEX 
	$blood = (split (/<p>/,$line))[10];
	@blood = split (/<s>/,$blood);
# 0= Own parent / 1= Other Parent / 2= Own Grandparent / 345= Other Grandparents
# 6= Own Great-grandparent / 7-13= Other Great-grandparents
	for ($i = 0; $i < 2; $i++) {
		($b_no[$i],$b_name1[$i],$b_sedai[$i]) = split (/<>/,$blood[$i]);
		$b_name[$i] = "$b_name1[$i] $b_sedai[$i]";
	}
	print<<"_EOF_";
<TABLE BORDER=1 BGCOLOR="#003f3f" bordercolordark="lightblue">
<TR><TD align="center" valign="middle">
	<TABLE BORDER=0 bgcolor="$color" cellpadding=0 cellspacing=0>
	<TR><TD><IMG SRC="$gif" width=40 height=40></TD></TR>
	</TABLE>
	<FONT SIZE=2>weight:$status[0]</FONT><BR>
	</TD>
	<TD bgcolor="black">
	<TABLE BORDER=1>
	<TR><TH>$birth $name</TH><TH>HP</TH><TH>STM</TH><TH>STR</TH><TH>DEX</TH><TH>SPD</TH><TH>$b_name[1]</TH></TR>
	<TR><TH>generation $sedai / $owner / slime number $no to be born</TH><TH>$statusp[1]</TH><TH>$statusp[2]</TH><TH>$statusp[3]</TH><TH>$statusp[4]</TH><TH>$statusp[5]</TH><TH>$ip</TH></TR>
	</TABLE>
	</TD>
</TR>
</TABLE>
<HR>
_EOF_
	}
	print<<"_EOF_";
<CENTER>
[<A HREF="$backurl" target="_top">$backtitle</A>][<A HREF="$cginame?mode=title" target="top">Title</A>][<A HREF="$cginame?mode=rank">Ranking</A>]<BR>
</CENTER>
_EOF_
	print $html_foot;
}

# ----------------------------------------------------------
# Game Entrance 
# ----------------------------------------------------------

# Entrance Screen

sub enter_print {
	@users = &read ($userfile);
	$userdata = &user_set; 
	$name = (split (/<p>/,$userdata))[2];
	$sedai = (split (/<p>/,$userdata))[3];
	print $html_head;
	print<<"_EOF_";
<FORM METHOD="post" ACTION="$cginame">
Welcome, $user . Please select the mate for $name .<BR>
<INPUT TYPE="hidden" NAME="mode" VALUE="create">
<INPUT TYPE="hidden" NAME="user" VALUE="$user">
<INPUT TYPE="hidden" NAME="pass" VALUE="$FORM{'pass'}">
<big><FONT COLOR="#ffb0ff"><B>$name</B></FONT><sub>$sedai</sub></big> x 
_EOF_

	if ($ipflag == 0) {
		print "<SELECT NAME=\"sel\">\n";
		print "<OPTION VALUE=\"\">Mate\n";
		$rank=1;
		foreach $line (@rank) {
			$no = (split (/<p>/,$line))[1];
			$name = (split (/<p>/,$line))[2];
			$sedai = (split (/<p>/,$line))[3];
			$seed = (split (/<p>/,$line))[11];
			if ($seed > 0) {
				print "<OPTION VALUE=\"$no\">Rank $rank / $name $sedai\n";
			}
			$rank++;
		}
		print<<"_EOF_";
</SELECT>
<INPUT TYPE=submit VALUE="Mate!">
_EOF_
	} else {
		print "You can mate only once every hour.<BR>\n";
	}

	$print = &status_print ($userdata);
	print $print;
	print<<"_EOF_";
</FORM>
_EOF_
	print $html_foot;
}

sub user_set {
	$user = $FORM{'user'};
	if ($user eq '') {
		&error(1,'You need to have a username to register.');
	}
	if (length($user) > 16) { $user = substr($user,0,16); }
	&set_cookie;

	$match = 0;
	$time = time;
	$ipflag = 0;
	$ipad = $ENV{'REMOTE_ADDR'};
	$userdata = '';

	foreach $line (@users) {
		$checkuser = (split(/<p>/,$line))[4];
		$checkpass = (split(/<p>/,$line))[11];
		$checkip = (split(/<p>/,$line))[1];
		$checktime = (split(/<p>/,$line))[5];

		if ($checkuser eq $user) {
			$match = &pass_match ($FORM{'pass'},$checkpass);
			if (($time - 3600) < $checktime) {
				$ipflag = 1;
				if ($FORM{'mode'} eq 'create') {
					&error(1,'Do not try to recreate characters.');
				}
			}
			if ($match) { $userdata = $line; }
			else { 
				&error(1,'Wrong password, or that name is already taken.');
			}
		}
		if ($checkip eq $ipad && ($time - 3600) < $checktime) { 
			$ipflag = 1;
			if ($FORM{'mode'} eq 'create') {
				&error(1,'Do not try to recreate characters.');
			}
		}
	}
	$newbie = 0;
	if ($userdata eq '') {
		$newbie = 1;
		$userdata = &create_char ($eve,$adam);
	}
	return $userdata;
}

# ----------------------------------------------------------
# Create New Character
# ----------------------------------------------------------

sub create {
	@users = &read ($userfile,$userloc);
	$userdata = &user_set;
	$halfdata = &seed_set;
	$newdata = &create_char ($userdata,$halfdata);
	&user_save ($newdata);
	&create_print;
}

# Combine characters to create

sub create_char {
	local ($userdata,$halfdata) = @_;
	$dna1 = (split(/<p>/,$userdata))[9];
	$dna2 = (split(/<p>/,$halfdata))[9];
	$seed1 = &seed_create ($dna1);
	$seed2 = &seed_create ($dna2);
	$new_dna = "$seed1<m>$seed2";
	($status,$color,$gif) = &status_set ($new_dna);
	$new_no = (split(/<p>/,$users[0]))[0] + 1;
	if ($new_no == 1) { $new_no = 3; }
	$name = (split(/<p>/,$userdata))[2];
	$new_sedai = (split(/<p>/,$userdata))[3] + 1;
	$time = time;
	$new_blood = &blood_mix ($userdata,$halfdata);
	$ango = &encode_pass ($FORM{'pass'});
	if ($newbie) {
		$name = "FirstChild";
		$new_sedai = 0;
		if ($newbie == 2) {
			$name = "NoNameYet";
			$new_sedai = 1;
		}
		$newbie = 2;
	}

	$newdata = "$new_no<p>$ipad<p>$name<p>$new_sedai<p>$user<p>$time<p>$color<p>$gif<p>$status<p>$new_dna<p>$new_blood<p>$ango<p>0<p>d\n";
	return $newdata;
}

# User File saving, and deletion upon timeout 

sub user_save {
	@new = '';
	push(@new,$_[0]);
	foreach $line (@users) {
		$lineowner = (split(/<p>/,$line))[4];
		$linetime = (split(/<p>/,$line))[5];
		if (($time - 604800) < $linetime && $user ne $lineowner) {
			push(@new,$line);
		}
	}
	@new = sort {$b <=> $a} @new;
	&save ($userfile,$usertmp,$userloc,@new);
}

# Show new character

sub create_print {
	print $html_head;
	print<<"_EOF_";
<FORM METHOD="post" ACTION="$cginame" target="bottom">
The child of $name has been born!  Give it a name, and challenge the ranked slimes!<BR>
<INPUT TYPE="hidden" NAME="mode" VALUE="fight">
<INPUT TYPE="hidden" NAME="user" VALUE="$user">
<INPUT TYPE="hidden" NAME="pass" VALUE="$FORM{'pass'}">
Name: <INPUT type="text" name="name" size=18 value="$name">
<INPUT TYPE="submit" VALUE="Round 1...Fight!">
_EOF_

	$print = &status_print ($newdata);
	print $print;
	print<<"_EOF_";
This slime is number $new_no to be born into this realm.<BR>
</FORM>
_EOF_
	print $html_foot;
}

# Create new petigree

sub blood_mix {
	local ($data1,$data2) = @_;
	$blood1 = (split(/<p>/,$data1))[10];
	$blood2 = (split(/<p>/,$data2))[10];
	@blood1 = split (/<s>/,$blood1);
	@blood2 = split (/<s>/,$blood2);
# 0= Own parent / 1= Other Parent / 2= Own Grandparent / 345= Other Grandparents
# 6= Own Great-grandparent / 7-13= Other Great-grandparents

	$no1 = (split(/<p>/,$userdata))[0];
	$name1 = (split(/<p>/,$userdata))[2];
	$sedai1 = (split(/<p>/,$userdata))[3];
	$no2 = (split(/<p>/,$halfdata))[1];
	$name2 = (split(/<p>/,$halfdata))[2];
	$sedai2 = (split(/<p>/,$halfdata))[3];

	$p0 = "$no1<>$name1<>$sedai1";
	$p1 = "$no2<>$name2<>$sedai2";

	$p2 = @blood1[0];
	$p3 = @blood1[1];
	$p4 = @blood2[0];
	$p5 = @blood2[1];

	$p6 = @blood1[2];
	$p7 = @blood1[3];
	$p8 = @blood1[4];
	$p9 = @blood1[5];
	$pa = @blood2[2];
	$pb = @blood2[3];
	$pc = @blood2[4];
	$pd = @blood2[5];

	$new_blood = "$p0<s>$p1<s>$p2<s>$p3<s>$p4<s>$p5<s>$p6<s>$p7<s>$p8<s>$p9<s>$pa<s>$pb<s>$pc<s>$pd";
	return $new_blood;
}

# Get data from mate

sub seed_set {
	@lines = &read ($rankfile,$rankloc);
	$seekno = $FORM{'sel'};
	if ($seekno eq '') {
		&error(1,'Please select a mate.');
	}
	@new = '';
	$halfflag = 0;
	foreach $line (@lines) {
		($a0,$no,$a2,$a3,$a4,$a5,$a6,$a7,$status,$a9,$b0,$seedrest,$child,$b3,$sperm,$b5) = split(/<p>/,$line);
		if ($no eq $seekno) {
			if ($seedrest < 1) {
				&error(1,'That slime has no seeds left to offer.');
			}
			$halfdata = $line;
			$halfflag = 1;
			$seedrest -= 1;
			$child += 1;
		}
		$sex = (split(/<>/,$status))[7];
		$sperm += $sex;
		if ($sperm > $seed_gage) {
			$sperm -= $seed_gage;
			$seedrest += 1;
		}
		push(@new,"$a0<p>$no<p>$a2<p>$a3<p>$a4<p>$a5<p>$a6<p>$a7<p>$status<p>$a9<p>$b0<p>$seedrest<p>$child<p>$b3<p>$sperm<p>$b5");
	}
	if ($halfflag == 0) {
		&error(1,'That slime is no longer ranked, so you cannot use it.');
	}
	&save ($rankfile,$ranktmp,$rankloc,@new);
	return $halfdata;
}

# Create seeds

sub seed_create {
	local ($dna) = $_[0];
	local ($seed,$part,$dna1,$dna2,$rnd,$dice,$para,$parap);
	$seed = '';
	($dna1,$dna2) = split (/<m>/,$dna);
	for ($i = 0; $i < 16; $i++) {
		$rnd = &rnd;
		if ($rnd) { $part = (split (/<s>/,$dna1))[$i]; }
		else { $part = (split (/<s>/,$dna2))[$i]; }
		if ($i < 7) {
			($para,$parap) = split (/<>/,$part);
			$dice = &dice;
			$para += $dice - ($tumble * (1 + $range) / 2);
			$para = $para * ($para > 0) + ($para < 1);
			$dice = &dice;
			$parap += $dice - ($tumble * (1 + $range) / 2);
			$part = "$para<>$parap";
		}
		$seed .= $part;
		if ($i < 15) { $seed .= '<s>'; }
	}
	return $seed;
}

# Setting Status.

sub status_set {
	local ($dna) = $_[0];
# @para:0=HRD 1=SFT 2=BRN 3=NET 4= FAT 5=MEN 6=SEX
# 	7=RED 8=GRN 9=BLU 10=X  11=Y  12=Z  13=Ribbon 14=Crown  15=Wings
	@para = &dna_trans($dna);
	$para[5] -= ($para[5] > ($para[2] * 2)) * ($para[5] - ($para[2] * 2));
	$wgt = int (($para[0] * 2 + $para[1]  * 3 + $para[2] + $para[4] * 5) / 11);
	$hp  = int (($para[0] + $para[1] + $para[4]) * 10 / 3);
	$stm = int (($para[4] + $para[5]) * 10 / 2);
	$str = int (($para[0] + $para[1] + $wgt * 3) / 5);
	$dex = int (($para[1] + $para[3]) / 2 * $para[2] / $wgt) + 1;
	$spd = int ($para[1] * $para[3] / $wgt) + 1;
	$cst = int (($wgt * 3 + $para[2] + $para[3] + $para[6]) / 6);
	$sex = int ($para[6] / $cst * 100) + 1;
	$status = "$wgt<>$hp<>$stm<>$str<>$dex<>$spd<>$cst<>$sex";

# Mutants!

	$rgb = $para[7] + $para[8] + $para[9];
	$xyz = $para[10] + $para[11] + $para[12];
	$uvw = $para[13] + $para[14] + $para[15];
	$dnaflag = 0;
	$rgbup = 0;
	$rgbdn = 0;
	$xyzup = 0;
	$xyzdn = 0;
	$uvwup = 0;
	$uvwdn = 0;
	if ($rgb == 0 && int (rand ($henka)) == 0) { $dnaflag = 1; $rgbup = 1; }
	if ($rgb == 6 && int (rand ($henka)) == 0) { $dnaflag = 1; $rgbdn = 1; }
	if ($xyz == 0 && int (rand ($henka)) == 0) { $dnaflag = 1; $xyzup = 1; }
	if ($xyz == 6 && int (rand ($henka)) == 0) { $dnaflag = 1; $xyzdn = 1; }
	if ($uvw == 0 && int (rand ($henka)) == 0) { $dnaflag = 1; $uvwup = 1; }
	if ($uvw == 6 && int (rand ($henka)) == 0) { $dnaflag = 1; $uvwdn = 1; }
	if ($dnaflag) {
		($dna[0],$dna[1]) = split (/<m>/,$dna);
		for ($i = 0; $i < 2; $i++) {
			($d0,$d1,$d2,$d3,$d4,$d5,$d6,$r,$g,$b,$x,$y,$z,$u,$v,$w) = split (/<s>/,$dna[$i]);
			if ($rgbup) { $r = 1; $g = 1; $b =1; }
			if ($rgbdn) { $r = 0; $g = 0; $b =0; }
			if ($xyzup) { $x = 1; $y = 1; $z =1; }
			if ($xyzdn) { $x = 0; $y = 0; $z =0; }
			if ($uvwup) { $u = 1; $v = 1; $w =1; }
			if ($uvwdn) { $u = 0; $v = 0; $w =0; }
			$change[$i] = "$d0<s>$d1<s>$d2<s>$d3<s>$d4<s>$d5<s>$d6<s>$r<s>$g<s>$b<s>$x<s>$y<s>$z<s>$u<s>$v<s>$w";
		}
		$new_dna = "$change[0]<m>$change[1]";
		@para = &dna_trans($new_dna);
		$rgb = $para[7] + $para[8] + $para[9];
		$xyz = $para[10] + $para[11] + $para[12];
		$uvw = $para[13] + $para[14] + $para[15];
	}


# Color setting subroutine

	if ($para[7] == 0) {
		$red = '00';
		if ($para[10] == 1) { $red = '3f'; }
	}	elsif ($para[7] == 1) {
		$red = '7f';
	}	else {
		$red = 'ff';
		if ($para[10] == 1) { $red = 'bf'; }
	}
	if ($para[8] == 0) {
		$grn = '00';
		if ($para[11] == 1) { $grn = '3f'; }
	}	elsif ($para[8] == 1) {
		$grn = '7f';
	}	else {
		$grn = 'ff';
		if ($para[11] == 1) { $grn = 'bf'; }
	}
	if ($para[9] == 0) {
		$blu = '00';
		if ($para[12] == 1) { $blu = '3f'; }
	}	elsif ($para[9] == 1) {
		$blu = '7f';
	}	else {
		$blu = 'ff';
		if ($para[12] == 1) { $blu = 'bf'; }
	}
	$color = "#$red$grn$blu";

	$gif = $char_normal;
	if ($xyz == 6) {
		$gif = $char_aura;
		if ($uvw == 3) { $gif = $char_hider; }
		if ($para[15] == 2) { $gif = $char_wing; }
		if ($para[13] == 2) {
			$gif = $char_ribbon;
			if ($para[15] == 2) { $gif = $char_ribbonw; }
		}
		if ($para[14] == 2) {
			$gif = $char_crown;
			if ($para[13] == 2) {
				$gif = $char_aho;
				if ($rgb < 2) { $gif = $char_zombie; }
				if ($rgb == 6) { $gif = $char_oyaji; }
			}
			if ($para[15] == 2) { $gif = $char_crownw; }
		}
		if ($uvw == 6) {
			$gif = $char_musi;
			if ($rgb > 3) { $gif = $char_angel; }
			if ($rgb < 1) { $gif = $char_devil; }
		}
	}
	return ($status,$color,$gif);
}


# DNA Translation subroutine

sub dna_trans {
	local ($dna) = $_[0];
	local ($part1,$part2,$dna1,$dna2,$parap1,$para1,$parap2,$para2);
	@para = '';
	($dna1,$dna2) = split (/<m>/,$dna);
	for ($i = 0; $i < 16; $i++) {
		$part1 = (split (/<s>/,$dna1))[$i];
		$part2 = (split (/<s>/,$dna2))[$i];
		if ($i < 7) {
			($para1,$parap1) = split (/<>/,$part1);
			($para2,$parap2) = split (/<>/,$part2);
			if ($parap1 > ($parap2 + ($range - 1) * $tumble * 0.05)) { $para[$i] = $para1; }
			elsif (($parap1 + ($range - 1) * $tumble * 0.05) < $parap2) { $para[$i] = $para2; }
			else { $para[$i] = int (($para1 + $para2) / 3) + 1; }
		} else { $para[$i] = $part1 + $part2; }
	}
	return @para;
}

# ----------------------------------------------------------
# Battle Subroutine
# ----------------------------------------------------------

sub fight {
	@users = &read ($userfile,$userloc);
	$userdata = &user_set;
		($u_no,$u1,$u_name,$u3,$u4,$u5,$u6,$u7,$u_status,$u9,$ua,$ub,$check,$ud) = split(/<p>/,$userdata);
	if ($check) {
		&error(1,'You cannot retry a battle, or the server was busy and your battle was not saved.  Please retry mating once more.');
	}

	print $html_head;
	if ($FORM{'name'} ne '') { $u_name = $FORM{'name'}; }
	if (length($u_name) > 18) { $u_name = substr($u_name,0,18); }
	$checkeduser = "$u_no<p>$u1<p>$u_name<p>$u3<p>$u4<p>$u5<p>$u6<p>$u7<p>$u_status<p>$u9<p>$ua<p>$ub<p>1<p>$ud";
	&user_save ($checkeduser);

	@rank = &read ($rankfile,$rankloc);
	$u_pts = 1;
	$u_win = 0;
	$u_lose = 0;
	$loseflag = 0;
	$result_text = '';

	@new = '';
	@rank = sort {$a <=> $b} @rank;
	$rankend_pts = (split(/<p>/,$rank[0]))[0];
	$cut_length = length($rankend_pts) - 2;
	$cut_length *= ($cut_length > 0);
	$r = @rank;

	foreach $line (@rank) {
		($e_pts,$a1,$e_name,$e_sedai,$a4,$a5,$e_color,$a7,$e_status,$a9,$b0,$b1,$b2,$e_result,$b4,$b5) = split(/<p>/,$line);
		($e_win,$e_lose) = split(/<>/,$e_result);
		$e_pts = int ($e_pts / (10 ** $cut_length));
		unless ($loseflag) {
			if ($e_pts >= $u_pts || $r < 4) {
				&fight_set ($u_status,$e_status);
				if ($r == 1 && $loseflag) {
					($b5_rank,$b5_defend) = split(/<sup>/,$b5);
					$b5_defend += 1;
					$b5 = "rank 1<sup>$b5_defend</sup>\n";
				}
				print $result_text;
				$result_text = '';
			}
		}
		$e_result = "$e_win<>$e_lose";
		if ($b5 > $r || $b5 == 0) { $b5 = $b5 = $r . "\n"; }
		$newline = "$e_pts<p>$a1<p>$e_name<p>$e_sedai<p>$a4<p>$a5<p>$e_color<p>$a7<p>$e_status<p>$a9<p>$b0<p>$b1<p>$b2<p>$e_result<p>$b4<p>$b5";
		push(@new,$newline);
		$r--;
	}
	$iniseed = int ($sex[0] /10);
	$u_data = "$u_pts<p>$u_no<p>$u_name<p>$u3<p>$u4<p>$u5<p>$u6<p>$u7<p>$u_status<p>$u9<p>$ua<p>$iniseed<p>0<p>$u_win<>$u_lose<p>0<p>$rankmax\n";
	unshift (@new,$u_data);

# Defending Chapmpion, and Saving Rankings

	$champ = @new[@new-1];
	pop @new;

	@new = sort {$b <=> $a} @new;

	$ranger = $new[0];
	$champ_pts = (split(/<p>/,$champ))[0];
	$ranger_pts = (split(/<p>/,$ranger))[0];
	$king_flag = 0;
	if ($champ_pts < $ranger_pts) {
		($u_pts,$u1,$u_name,$u_sedai,$u4,$u5,$u_color,$u7,$u_status,$u9,$v0,$v1,$v2,$u_result,$v4,$v5) = split(/<p>/,$champ);
		($u_win,$u_lose) = split(/<>/,$u_result);
		($e_pts,$a1,$e_name,$e_sedai,$a4,$a5,$e_color,$a7,$e_status,$a9,$b0,$b1,$b2,$e_result,$b4,$b5) = split(/<p>/,$ranger);
		($e_win,$e_lose) = split(/<>/,$e_result);
		($v5_rank,$v5_defend) = split(/<sup>/,$v5);
		if ($loseflag == 0) {
			shift @new;
			unshift (@new,$champ);
			unshift (@new,$ranger);
			if ($v5_defend > ($dendo - 1)) { $king_flag = 1; }
		} else {
			$loseflag = 0;
			&fight_set ($u_status,$e_status);
			$u_result = "$u_win<>$u_lose";
			$e_result = "$e_win<>$e_lose";
			$champ = "$u_pts<p>$u1<p>$u_name<p>$u_sedai<p>$u4<p>$u5<p>$u_color<p>$u7<p>$u_status<p>$u9<p>$v0<p>$v1<p>$v2<p>$u_result<p>$v4<p>$v5";
			$ranger = "$e_pts<p>$a1<p>$e_name<p>$e_sedai<p>$a4<p>$a5<p>$e_color<p>$a7<p>$e_status<p>$a9<p>$b0<p>$b1<p>$b2<p>$e_result<p>$b4<p>$b5";
			if ($loseflag) {
				shift @new;
				unshift (@new,$champ);
				unshift (@new,$ranger);
				if ($v5_defend > ($dendo - 1)) { $king_flag = 1; }
			} else {
				$v5_defend += 1;
				$v5 = "1<sup>$v5_defend</sup>\n";
				$champ = "$u_pts<p>$u1<p>$u_name<p>$u_sedai<p>$u4<p>$u5<p>$u_color<p>$u7<p>$u_status<p>$u9<p>$v0<p>$v1<p>$v2<p>$u_result<p>$v4<p>$v5";
				shift @new;
				unshift (@new,$ranger);
				unshift (@new,$champ);
			}
		}
	} else {
		unshift (@new,$champ);
	}

	while (@new > $rankmax) { pop @new; }
	&save ($rankfile,$ranktmp,$rankloc,@new);

# enter "Hall of Fame
	if ($king_flag) {
		@king = &read ($kingfile,$kingloc);
		unshift (@king,$champ);
		&save ($kingfile,$kingtmp,$kingloc,@king);

		$FORM{'user'} = "Congratulations!";
		$FORM{'comt'} = "$u_name $u_sedai has entered the Hall of Fame.  Congratulations to its owner, $u4 !";
		&add_comt;
	}

	if ($u3 > 99) {
		$mania = "[<A HREF=\"$cginame?mode=mania\">Explain system</A>]";
	} else { $mania = ''; }

	print<<"_EOF_";
<FONT SIZE=2>[O]=Hit [X]=Missed [o]=Got hit [x]=Evaded</FONT>
<HR>
<CENTER>
[<A HREF="$backurl" target="_top">$backtitle</A>][<A HREF="$cginame?mode=rank">Ranking</A>][<A HREF="$cginame?mode=title" target="top">Title</A>]$mania
<BR>
</CENTER>
_EOF_
	print $html_foot;
}

sub fight_set {
	local (@status) = @_;
	for ($i = 0; $i < 2; $i++) {
		($wgt[$i],$maxhp[$i],$maxst[$i],$str[$i],$dex[$i],$spd[$i],$cst[$i],$sex[$i]) = split (/<>/,$status[$i]);
	}
# Self [$turn != 0]
# Opponent [$turn == 0]
	@gage = '';
	$turn = 0;
	$hit[0] = 0; $hit[1] = 0;
	$attack[0] = 0; $attack[1] = 0;
	$maxst[0] *= 8; $maxst[1] *= 8;
	$hp[0] = $maxhp[0]; $hp[1] = $maxhp[1];
	$st[0] = $maxst[0]; $st[1] = $maxst[1];
	$pow[0] = 1; $pow[1] = 1;
	$powx[0] = 1; $powx[1] = 1;
	$powy[0] = 1; $powy[1] = 1;
	$sum_rndhit[0] = 0; $sum_rndhit[1] = 0;
	$sum_hitper[0] = 0; $sum_hitper[1] = 0;
	$spd_gage = ($spd[0] >= $spd[1]) * $spd[0] + ($spd[0] < $spd[1]) * $spd[1] - 1;
	$fightlog = '';
	$round = 1;
	until ($hp[0] < 1 || $hp[1] < 1) {
		if ($gage[$turn != 0] > $spd_gage) {
			$gage[$turn != 0] -= $spd_gage;
			$attack[$turn != 0] += 1;
			$my_dex = $dex[$turn != 0] * $powx[$turn != 0];
			$rnd_hit = rand ($my_dex + $spd[$turn == 0] * $powx[$turn == 0]);
			$hit_per = 1 - ($rnd_hit / $my_dex) ** 2;
			$sum_rndhit[$turn != 0] += (1 - $rnd_hit / ($my_dex + $spd[$turn == 0] * $powx[$turn == 0]));
			if ($rnd_hit < $my_dex) {
				$hit[$turn != 0] += 1;
				$hp[$turn == 0] -= int ($str[$turn != 0] * $hit_per * $powx[$turn != 0]);
				$st[$turn == 0] -= int ($cst[$turn != 0] * $hit_per * 1.25 * $powy[$turn != 0]);
				$sum_hitper[$turn != 0] += $hit_per;
				if ($turn == 0) {
					$fightlog .= "O";
				} else { 
					$fightlog .= "o";
				}
			} else {
				if ($turn == 0) {
					$fightlog .= "X";
				} else { 
					$fightlog .= "x";
				}
			}
			$st[$turn != 0] -= $cst[$turn != 0] * $powy[$turn != 0];
			$st[$turn == 0] -= int ($cst[$turn != 0] * 0.25 * $powy[$turn != 0]);
			$st[$turn != 0] *= ($st[$turn != 0] > 0);
			$st[$turn == 0] *= ($st[$turn == 0] > 0);
			$pow[$turn != 0] = $st[$turn != 0] / $maxst[$turn != 0];
			$pow[$turn == 0] = $st[$turn == 0] / $maxst[$turn == 0];
			$powx[$turn != 0] = 0.4 + 0.6 * (1 - (1 - $pow[$turn != 0]) ** 2);
			$powx[$turn == 0] = 0.4 + 0.6 * (1 - (1 - $pow[$turn == 0]) ** 2);
			$powy[$turn != 0] = 0.6 + 0.4 * (1 - (1 - $pow[$turn != 0]) ** 2);
			$powy[$turn == 0] = 0.6 + 0.4 * (1 - (1 - $pow[$turn == 0]) ** 2);
			if (!($round % 10)) {
				$fightlog .= " ";
			}
			$round++;
		}
		$gage[$turn != 0] += int ($spd[$turn != 0] * $powx[$turn != 0]);
		$turn = ($turn == 0);
	}
	if ($turn) { &fight_win; }
	else { &fight_lose; }
}

sub fight_win {
	$u_pts += $e_pts;
	$u_win += 1;
	$e_lose += 1;
	$result_msg=<<"_EOF_";
<FONT SIZE=7 color="red" FACE="Times New Roman"><i>YOU WIN!</i></FONT><BR>
NOW $u_pts<small>pts.</small><BR>
_EOF_
	if ($r == 1) {
		$cong=<<"_EOF_";
<BR>
<FONT SIZE=7 color="yellow" FACE="Times New Roman"><i>
Congratulations!<BR>
You are the new CHAMPION!<BR>
</i></FONT>
_EOF_
		$result_msg .= $cong;
	}
	&fight_print;
}

sub fight_lose {
	$e_pts += $u_pts;
	$e_win += 1;
	$u_lose += 1;
	$result_msg=<<"_EOF_";
<FONT SIZE=7 color="blue" FACE="Times New Roman"><i>YOU LOSE!</i></FONT><BR>
TOTAL $u_pts<small>pts.</small><BR>
_EOF_
	$loseflag = 1;
	&fight_print;
}

sub fight_print {
	$print1=<<"_EOF_";
<BIG><B><FONT COLOR="yellow">versus</FONT> (rank $r ) <FONT COLOR="#ffb0ff">$e_name</FONT></B><sub>$e_sedai</sub></BIG> $b1 seeds / $b2 children / $e_win - $e_lose / Was up to rank $b5 / $e_pts<small>pts.</small><BR>
_EOF_

	$print2 = &status_print ($line);

	$pow[0] = int ($pow[0] * 100);
	$pow[1] = int ($pow[1] * 100);
	$dmg_ave[0] = 0;
	$dmg_ave[1] = 0;
	if ($hit[0]) { $dmg_ave[0] = int (($maxhp[1] - $hp[1]) / $hit[0]); }
	if ($hit[1]) { $dmg_ave[1] = int (($maxhp[0] - $hp[0]) / $hit[1]); }
	if ($hit[0]) { $luck_hit[0] = int (100 * $sum_hitper[0] / $hit[0]); }
	if ($hit[1]) { $luck_hit[1] = int (100 * $sum_hitper[1] / $hit[1]); }
	if ($attack[0]) { $luck_atk[0] = int (100 * $sum_rndhit[0] / $attack[0]); }
	if ($attack[1]) { $luck_atk[1] = int (100 * $sum_rndhit[1] / $attack[1]); }
	$print3=<<"_EOF_";
<TABLE BORDER=0>
<TR bgcolor="#00007f"><TD>$u_name </TD><TD>HP:<FONT COLOR="yellow">$hp[0]</FONT>/<sub>$maxhp[0]</sub> </TD><TD>STM: $pow[0]% </TD><TD>$hit[0] Hits Landed / </TD><TD>$attack[0] Attacks Attempted </TD><TD>DmgAve $dmg_ave[0] </TD><TD>LUCK: $luck_atk[0]($luck_hit[0])</TD></TR>
<TR><TD>$e_name </TD><TD>HP:<FONT COLOR="yellow">$hp[1]</FONT>/<sub>$maxhp[1]</sub> </TD><TD>STM: $pow[1]% </TD><TD>$hit[1] Hits Landed / </TD><TD>$attack[1] Attacks Attempted</TD><TD>DmgAve $dmg_ave[1] </TD><TD>LUCK: $luck_atk[1]($luck_hit[1])</TD></TR>
</TABLE>
<BR>
<CENTER>
$result_msg
</CENTER>
<BR>
$fightlog
<HR>
_EOF_

	$result_text .= "$print1$print2$print3";
}

# ----------------------------------------------------------
# Random Number Generator
# ----------------------------------------------------------

# return binary
sub rnd {
	$rnd = int (rand (2));
	return $rnd;
}

# return a dice number
sub dice {
	local ($dice,$j);
	$dice = 0;
	for ($j = 0; $j < $tumble; $j++) {
		$dice += int (1 + rand ($range));
	}
	return $dice;
}

# ----------------------------------------------------------
# Cookies
# ----------------------------------------------------------

sub set_cookie {
	# Cookies are valid for 7 days
	($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg)
		 				= gmtime(time + 7*24*60*60);

	$yearg += 1900;
	if ($secg  < 10) { $secg  = "0$secg";  }
	if ($ming  < 10) { $ming  = "0$ming";  }
	if ($hourg < 10) { $hourg = "0$hourg"; }
	if ($mdayg < 10) { $mdayg = "0$mdayg"; }

	$month = ('Jan','Feb','Mar','Apr','May','Jun','Jul',
				'Aug','Sep','Oct','Nov','Dec')[$mong];
	$youbi = ('Sunday','Monday','Tuesday','Wednesday',
				'Thursday','Friday','Saturday')[$wdayg];

	$date_gmt = "$youbi, $mdayg\-$month\-$yearg $hourg:$ming:$secg GMT";
	$cook="user\:$user\,pwd\:$FORM{'pass'}";
	print "Set-Cookie: slime=$cook; expires=$date_gmt\n";
}

sub get_cookie { 
	@pairs = split(/;/, $ENV{'HTTP_COOKIE'});
	foreach $pair (@pairs) {
		local($name, $value) = split(/=/, $pair);
		$name =~ s/ //g;
		$DUMMY{$name} = $value;
	}
	@pairs = split(/,/, $DUMMY{'slime'});
	foreach $pair (@pairs) {
		local($name, $value) = split(/:/, $pair);
		$COOKIE{$name} = $value;
	}
	$c_name  = $COOKIE{'user'};
	$c_pwd   = $COOKIE{'pwd'};
}

# ----------------------------------------------------------
# Password
# ----------------------------------------------------------

sub encode_pass {
	$now = time;
	($pack1, $pack2) = unpack("C2", $now);
	$wk = $now / (60*60*24*7) + $pack1 + $pack2 - 8;
	@saltset = ('a'..'z','A'..'Z','0'..'9','.','/');
	$nsalt = $saltset[$wk % 64] . $saltset[$now % 64];
	$ango = crypt($_[0], $nsalt);
	return $ango;
}

sub pass_match {
	local ($inputpass,$checkpass) = @_;
	if ($checkpass eq crypt ($inputpass,substr ($checkpass,0,2))) {
# Change to <<substr ($checkpass,3,2)>> on FreeBSD servers
		$match = 1;
	} else { $match = 0; }
	return $match;
}

# ----------------------------------------------------------
# Get date
# ----------------------------------------------------------

sub date {
	local ($time) = $_[0];
	($sec,$min,$hour,$day,$mon) = localtime($time);
	$mon++;
	if ($sec < 10)  { $sec  = "0$sec";  }
	if ($min < 10)  { $min  = "0$min";  }
	if ($hour < 10) { $hour = "0$hour"; }
	if ($day < 10)  { $day  = "0$day";  }
	if ($mon < 10)  { $mon  = "0$mon";  }

	$date = "$mon/$day $hour:$min";
	return $date;
}

# ----------------------------------------------------------
# Dealing with the record files
# ----------------------------------------------------------

sub read {
	local($logfile,$lockfile) = @_;
	if ($lockfile) {
		foreach (1 .. 45) {
			unless (-f $lockfile) {
				open(LOC,">$lockfile") || die "Can't create lock file.\n";
				close(LOC);
				push(@locklist,$lockfile);
				last;
			}
			sleep(1);
		}
	}
	if (!open(IN,$logfile)) { &error(1,"Cannot read stored data"); }
	local(@files) = <IN>;
	close(IN);
	return @files;
}

sub save {
	local($logfile,$tmpfile,$lockfile,@lines) = @_;
	$tmp_dummy = "$$\.tmp";
	open(TMP,">$tmp_dummy") || die "Can't create tmp file.\n";
	close(TMP);
	chmod 0666,$tmp_dummy;
	open(TMP,">$tmp_dummy") || die "Can't open tmp file.\n";
	print TMP @lines;
	close(TMP);
	foreach (1 .. 30) {
		if (link($tmp_dummy,$tmpfile) == 1) {
			last;
		}
		sleep(1);
	}
	rename($tmpfile,$logfile); 
	chmod 0644,$logfile;
	unlink $tmp_dummy;
	if (-f $lockfile) { unlink $lockfile; }
}

# ----------------------------------------------------------
# Get data from the forms
# ----------------------------------------------------------

sub read_form {
    local($pair,$buffer);
    if ($ENV{'REQUEST_METHOD'} eq "POST") { read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); } else { $buffer = $ENV{'QUERY_STRING'}; }
    local(@pairs) = split(/&/,$buffer);
    foreach $pair (@pairs) {
        local($name,$value) = split(/=/,$pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
        $FORM{$name} = &change_code($value);
    }
}

# ----------------------------------------------------------
# get rid of what may be perceived as html
# ----------------------------------------------------------
 
sub change_code {
    local($text)=$_[0];
    $text =~ s/\&/&amp;/g;
    $text =~ s/</&lt;/g;
    $text =~ s/>/&gt;/g;
	$text =~ s/"/&quot;/g;
    return $text;
}

# ----------------------------------------------------------
# Dealing with Errors
# ----------------------------------------------------------

sub error {
	($err,$err_msg) = @_;
	if ($err) {
		print $html_head;
		print<<"_EOF_";
<FONT COLOR="red"><B>Error: $err_msg</B></FONT><BR>
<A HREF="$cginame" target="_top">Reload</A><BR>
</BODY></HTML>
_EOF_
		print $html_foot;
	}
	foreach $line (@locklist) {
		if (-f $line) { unlink $line; }
	}
	exit;
}

# ----------------------------------------------------------
# Instructions
# ----------------------------------------------------------

sub guide {
	print $html_head;
	print<<"_EOF_";
	
* Limitations of length<BR>
Your username can be up to 16 letters.<BR>
Name of the slime can be up to 18 letters.<p>

* About this game<BR>
This game is a genetic evolutio simulator.<br>
Each entity has its own DNA, and the status<br>
as well as physical characteristics are all<br>
predetermined by the DNA.<br>
All you have to do is mate your slime with <br>
others in hopes of making it stronger.<p>

* How to play<br>
Choose your mate for your slime.<br>
That's it.<br>
... or rather, that's all you can do. (^^;)<br>
It's rather easy.<br>
Until you get the hang of it, just randomly<br>
select your mates.<br>
It will become more complex as you figure<br>
out what all the information means.<br>
However, whether or not you create strong<br>
slimes do not depend on how well you can<br>
parse all the information.<br>
Just understand what is there, and enjoy<br>
the game.<br>
You cannot choose slimes with no seeds left<br>
to be your mate.<br>
And when you have a new slime, fight with it.<br>
It will fight from the bottom of the rankings,<br>
fighting up the latter based on how many points<br>
it receives, until it loses.<br>
To avoid congesting the server, you can play<br>
up to once per hour.<br>
If you do not play for over a week, your<br>
data will be deleted automatically.<p>

* How to look at the slimes<br>

<big><B>Rank 20<FONT COLOR="#ffb0ff">Sample</B></FONT><sub>24</sub></big> / <FONT COLOR="yellow">11</FONT>seeds left / 0 children / 3 - 1 / Highest rank: 5 / 
47<small>pts.</small><BR>
<TABLE BORDER=1 BGCOLOR="#003f3f" bordercolordark="lightblue">
<TR><TD align="center" valign="middle">
	<TABLE BORDER=0 bgcolor="#7fff7f" cellpadding=0 cellspacing=0>
	<TR><TD><IMG SRC="./slmnormal.gif" width=111 height=111></TD></TR>
	</TABLE>
	<FONT SIZE=2>weight:324</FONT><BR>
	</TD>
	<TD background="$bg_gif">
	<TABLE BORDER=1>
	<TR><TH>generation 24Fborn 10/10 11:19</TH><TH>HP</TH><TH>STM</TH><TH>STR</TH><TH>DEX</TH><TH>SPD</TH></TR>
	<TR><TH>Owner: tatuta</TH><TH>333</TH><TH>299</TH><TH>41</TH><TH>163</TH><TH>218</TH></TR>
	</TABLE>
	<TABLE BORDER=1>
	<TR><TD valign="middle">
		<A href="#24096">BIG*ONE</A><FONT COLOR="yellow"><sub>23</sub></FONT><BR>
		<HR>
		<A href="#24164">Mom</A><sub>26</sub><BR>
		</TD>
	<TD valign="middle">
		<FONT SIZE=2><A href="#24052">BIG*BLUE</A> <FONT COLOR="yellow">22</FONT></FONT><BR>
		<FONT SIZE=2><A href="#24086">125MillionYen</A> 8</FONT><BR>
		<HR>
		<FONT SIZE=2><A href="#24109">Mom</A> 25</FONT><BR>
		<FONT SIZE=2><A href="#24156">TougokuShireiha</A> 31</FONT><BR>
		</TD>
	<TD valign="top">
		<FONT SIZE=2><A href="#24022">BE*BORED</A> <FONT COLOR="yellow">21</FONT></FONT><BR>
		<FONT SIZE=2><A href="#24030">MoeRestart</A> 7</FONT><BR>
		<FONT SIZE=2><A href="#22069">125MillionChild</A> 7</FONT><BR>
		<FONT SIZE=2><A href="#24063">RoboNishidaG7</A> 24</FONT><BR>
		</TD>
	<TD valign="bottom">
		<FONT SIZE=2><A href="#24073">Mom</A> 24</FONT><BR>
		<FONT SIZE=2><A href="#23705">Taiga</A> 28</FONT><BR>
		<FONT SIZE=2><A href="#24148">TougokuShireiha</A> 30</FONT><BR>
		<FONT SIZE=2><A href="#23872">Marto</A> 23</FONT><BR>
		</TD>
	</TR>
	</TABLE>
	</TD>
</TR>
</TABLE>
I will now explain in order.<br>
The rankings are point-based.<br>
<TABLE BORDER=1>
<TR>
<TD><big><B>Rank 20</B></BIG></TD>
<TD><BIG><B><FONT COLOR="#ffb0ff">Sample</B></FONT></BIG></TD>
<TD><BIG><sub>24</sub></big></TD>
<TD><FONT COLOR="yellow">11</FONT> seeds left</TD>
<TD>0 children</TD>
<TD>3 - 1</TD>
<TD>Highest rank: 5</TD>
<TD>47<small>pts.</small></TD>
</TR>
<TR><TD>Current rank</TD><TD>Name of your slime</TD><TD>Generation of your slime</TD><TD>Number of seeds left</TD><TD>Number of children it has had</TD><TD>Battle record</TD><TD>Highest ranking achieved</TD><TD>Current point total</TD></TR>
</TABLE>
<TABLE BORDER=1 BGCOLOR="#003f3f" bordercolordark="lightblue">
<TR><TD align="center" valign="middle">
	<TABLE BORDER=0 bgcolor="#7fff7f" cellpadding=0 cellspacing=0>
	<TR><TD><IMG SRC="./slmnormal.gif" width=111 height=111></TD></TR>
	</TABLE>
	<FONT SIZE=2>weight:324</FONT><BR>
	</TD>
	<TD bgcolor="#000000">The slime's appearance and weight</TD>
	</TR>
</TABLE>
<TABLE BORDER=1>
<TR><TH>generation 24: born 10/10 11:19</TH><TH>HP</TH><TH>STM</TH><TH>STR</TH><TH>DEX</TH><TH>SPD</TH></TR>
<TR><TH>Owner: tatuta</TH><TH>333</TH><TH>299</TH><TH>41</TH><TH>163</TH><TH>218</TH></TR>
</TABLE>
The slime's generation, birthday, and the owner name is shown here.<BR>
The generation is also the number of times the owner has played the game.<P>

* Explanation of each parameter<BR>
<TABLE BORDER=1>
<TR><TD>HP</TD><TD>
	If your slime's Hit Points go to zero, your slime loses.<BR>
	</TD></TR>
<TR><TD>STM</TD><TD>
	Your slime's stamina will decrease upon giving or receiving a blow.<br>
	If attacking loses 4 stamina points, evading a blow will lose 1 point<br>
	and receiving a blow will lose 6.<br>
	As your slime loses stamina, it will become weaker overall;<br>
	it will become increasingly weaker when the stamina goes below 50%.<br>
	If stamina goes to 0, it will only be as half as strong as when it started.<br>
	When it goes low on stamina, the rate with which stamina decreases will<br>
	also slow down.<br>
	</TD></TR>
<TR><TD>STR</TD><TD>
	Strength is how large the damage is upon each hit.<BR>
	</TD></TR>
<TR><TD>DEX</TD><TD>
	Dexterity determines the probability of the attack hitting the opponent.<BR>
	</TD></TR>
<TR><TD>SPD</TD><TD>
	Speed determines the number of hits given and ability to evade.<BR>
	</TD></TR>
</TABLE>
Furthermore, heavy slimes have larger strenth but lower dexterity and speed.<br>
Large slimes are more powerful, and smaller ones are quicker.<br>
Those with high status will use more stamina per turn as well.<br>
When the status runs out of digits, the number of digits shown will automatically<br>
be decreased for easier visibility.<p>

	<TABLE BORDER=1>
	<TR><TD valign="middle">
		<A href="#24096">BIG*ONE</A><FONT COLOR="yellow"><sub>23</sub></FONT><BR>
		<HR>
		<A href="#24164">Mom</A><sub>26</sub><BR>
		</TD>
	<TD valign="middle">
		<FONT SIZE=2><A href="#24052">BIG*BLUE</A> <FONT COLOR="yellow">22</FONT></FONT><BR>
		<FONT SIZE=2><A href="#24086">125MillionYen</A> 8</FONT><BR>
		<HR>
		<FONT SIZE=2><A href="#24109">Mom</A> 25</FONT><BR>
		<FONT SIZE=2><A href="#24156">TougokuShireiha</A> 31</FONT><BR>
		</TD>
	<TD valign="top">
		<FONT SIZE=2><A href="#24022">BE*BORED</A> <FONT COLOR="yellow">21</FONT></FONT><BR>
		<FONT SIZE=2><A href="#24030">MoeRestart</A> 7</FONT><BR>
		<FONT SIZE=2><A href="#22069">125MillionChild</A> 7</FONT><BR>
		<FONT SIZE=2><A href="#24063">RoboNishidaG7</A> 24</FONT><BR>
		</TD>
	<TD valign="bottom">
		<FONT SIZE=2><A href="#24073">Mom</A> 24</FONT><BR>
		<FONT SIZE=2><A href="#23705">Taiga</A> 28</FONT><BR>
		<FONT SIZE=2><A href="#24148">TougokuShireiha</A> 30</FONT><BR>
		<FONT SIZE=2><A href="#23872">Marto</A> 23</FONT><BR>
		</TD>
	</TR>
	</TABLE>
	
This is the slime's pedigree.<br>
If you are familiar with horse-racing, this might sound familiar.<br>
When you click on the name, the slime will show up on screen if<br>
it is still ranked.<br>
The furthest left is your slime's parents.<br>
To the right is the grandparents.<br>
Further right are the great-grandparents of your half.<br>
Far right are the great-grandparents of the other half.<br>
It should actually look more like<br> 
	
<TABLE BORDER=1>
<TR>
<TD valign="middle" rowspan=4>
	<A href="#24096">BIG*ONE</A><FONT COLOR="yellow"><sub>23</sub></FONT><BR>
	</TD>
<TD valign="middle" rowspan=2>
	<FONT SIZE=2><A href="#24052">BIG*BLUE</A> <FONT COLOR="yellow">22</FONT></FONT><BR>
	</TD>
<TD valign="middle">
	<FONT SIZE=2><A href="#24022">BE*BORED</A> <FONT COLOR="yellow">21</FONT></FONT><BR>
	</TD></TR>
<TR><TD valign="middle">
	<FONT SIZE=2><A href="#24030">MoeRestart</A> 7</FONT><BR>
	</TD></TR>
<TR><TD valign="middle" rowspan=2>
	<FONT SIZE=2><A href="#24086">125MillionYen</A> 8</FONT><BR>
	</TD>
<TD valign="middle">
	<FONT SIZE=2><A href="#22069">125MillionChild</A> 7</FONT><BR>
	</TD></TR>
<TR><TD valign="middle">
	<FONT SIZE=2><A href="#24063">RoboNishidaG7</A> 24</FONT><BR>
	</TD></TR>
<TR><TD valign="middle" rowspan=4>
	<A href="#24164">Mom</A><sub>26</sub><BR>
	</TD>
<TD valign="middle" rowspan=2>
	<A href="#24109">Mom</A> 25</FONT><BR>
	</TD>
<TD valign="middle">
	<FONT SIZE=2><A href="#24073">Mom</A> 24</FONT><BR>
	</TD></TR>
<TR><TD valign="middle">
	<FONT SIZE=2><A href="#23705">Taiga</A> 28</FONT><BR>
	</TD></TR>
<TR><TD valign="middle" rowspan=2>
	<FONT SIZE=2><A href="#24156">TougokuShireiha</A> 31</FONT><BR>
	</TD>
<TD valign="middle">
	<FONT SIZE=2><A href="#24148">TougokuShireiha</A> 30</FONT><BR>
	</TD></TR>
<TR><TD valign="middle">
	<FONT SIZE=2><A href="#23872">Marto</A> 23</FONT><BR>
	</TD></TR>
</TABLE>

... but for spacial reasons, the petigree is listed more like the<br>
first table.<br>
The number to the bottom right of the name is the generation number.<p>

* Battle result report<br>
<TABLE BORDER=0>
<TR bgcolor="#00007f"><TD>FOR*EXAMPLE </TD><TD>HP:<FONT COLOR="yellow">-17</FONT>/<sub>4823</sub> </TD><TD>STM: 20% </TD><TD>HIT 12</TD><TD>/ATTACK 32 times</TD><TD>DmgAve 325 </TD><TD>LUCK: 49(74)</TD></TR>
<TR><TD>Sample </TD><TD>HP:<FONT COLOR="yellow">56</FONT>/<sub>3963</sub> </TD><TD>STM: 5% </TD><TD>HIT 21</TD><TD>/ATTACK 44 times </TD><TD>DmgAve 230 </TD><TD>LUCK: 54(57)</TD></TR>
</TABLE>
This is the information from the battle results.<br>
HP: Remaining hit points.  The denominator is the maximum HP.<br>
STM: Remaining stamina points.  From this you can see when your<br>
&nbsp;&nbsp;slime started to lose stamina.<br>
HIT/ATTACK: Number of attacks landed / attempted.<br>
DmgAve: Damage Average.<br>
Luck: The average of all random numbers generated between battle.<br>
&nbsp;&nbsp;The larger this is, the luckier you were.<br>
&nbsp;&nbsp;The first number is the hit estimate.  This goes from 0<br>
&nbsp;&nbsp;to 100, and the target number is 50.<br>
&nbsp;&nbsp;The number in parenthesis is the damage estimate.  This<br>
&nbsp;&nbsp;also goes from 0 to 100, and the target number si 67.<p>

<CENTER>
<FONT SIZE=7 color="red" FACE="Times New Roman"><i>YOU WIN!</i></FONT><BR>
NOW 11<small>pts.</small><BR>
</CENTER>
This means your slime currently built up 11 points.<BR>
<CENTER>
<FONT SIZE=7 color="blue" FACE="Times New Roman"><i>YOU LOSE!</i></FONT><BR>
TOTAL 11<small>pts.</small><BR>
</CENTER>
When you lose, your final point total will be shown.<BR>
<BR>
xXxOxXxOxx XxXooXoXoo XxXooXoOxo OoOoxOoXxX xoXxXxoXxX xoXXxxOxXo oXxOxoOxOx XoOoOo<BR>
This is the battle log.  It starts from the left, and flows to the right.<br>
The large XO are your attacks. O is a hit, X is a miss.<br>
The small xo are the opponent's attacks.  Likewise, o is a hit and x is a miss.<p>

* How the ranking works.
Rankings are based on points.<br>
Each ranked slime has their own points, and you can get those points when<br>
you win.<br>
You cannot lose points just by losing.<br>
Every slime created starts with one point, and will fight from the<br>
lowest ranked slime and up the ladder, fighting only with slimes that<br>
have more points than itself (except for the top three slimes, which<br>
it will always fight).<br>
Points are awared for slimes that break a winning streak.<br>
When the battle ends, the rankings will be rearranged based on these<br>
point totals.<br>
The top-ranking slime is special, and if there is a slime that has<br> 
more points than it, a special match will take place.  If the top-<br>
ranking slime defends the title, the number of times it has defended<br>
the title will show up next to the rank. iHighest rank: 1<sup>1<FONT COLOR="yellow">&lt;-this<br>
thing</FONT></sup>j<p>

* Hall of Fame<BR>
Slimes that have defended the top rank more than $dendo times<BR>
will enter the Hall of Fame as one of the legends.<BR>
Its name will live on for future generations.<br>
A slime will enter the Hall of Fame when it fails to defend its title,<br>
and the data recorded will be from when it falls from the top rank.<p>

* About the DNA.<br>
Physical characteristics such as muscles, brains, and reflexes<br>
are passed on from generation to generation.<br>
Statuses such as STR are determined from a complex algorhythm of<br>
such characteristics.<br>
Each slime will receive half of the DNA from each parent, and each<br>
parameter contains two separate strands.<br>
Of the two, the dominant one will appear in the status, and the<br>
other one will not appear in the status charts.<br>
The trait that does not appear may show up in the generation<br>
after the current one.  This is how generation jumps are simulated.<br>
The creator's interpretation of inbreeding is to increase the<br>
chances of having a certain ancestor's DNA.<br>
Perhaps such inbreeding will give good results.<p>

* About evolution.<br>
The program makes sure that the probability for the slime getting<br>
stronger is the same as it getting weaker.<br>
However, because the number of ranked slimes is limited, and because<br>
most everyone will choose stronger slimes to mate with, that probability<br>
shifts somewhat.<br>
Weaker slimes will have a smaller chance of leaving offspring.<br>
Thus, even if getting stronger or weaker has the same probability,<br>
it is believed that the slimes will evolve as a species.<br>
That is the intent of the programmer.<br>
So, let us watch how the slimes will evolve.<p>

* Other comments.<br>
Several mutations are hidden within the algorhythms.  They will appear<br>
if the conditions are met.  There are a few varieties... will you see<br>
them all?<p>

* A story from the programmer.<br>
God was bored, and created slimes from clay.<br>
One was a black slime named Adam that had nothing.<br>
The other was a white slime named Eve that had many things.<br>
Adam created seeds.  Eve ate those seeds.<br>
Eve's body changed in many ways.<br>
She became a grey slime.<br>
Every Eve that ate Adam's seed became gray.<br>
Soon there were many slimes, and one day ran out of food.<br>
And so the battles began.<p>

* an FAQ just for the English version (compiled by the translator)<br>
--Can I have more than one login?<br>
&nbsp;&nbsp;&nbsp;<i>sure, especially if you have multiple IP's.</i><br>
--Can I use an old slime of mine as my side of the parents?<br>
&nbsp;&nbsp;&nbsp;<i>I'm afraid not.  This is an evolution sim
after<br>
&nbsp;&nbsp;&nbsp;all... we need to go forward.  So mate once,
fight<br>
&nbsp;&nbsp;&nbsp;once, and then make new offspring. =)<br>
&nbsp;&nbsp;&nbsp;but then, nobody is stopping you from
inbreeding...</i><br>
--How long to the slimes stay in the ranks?<br>
&nbsp;&nbsp;&nbsp;<i>until they drop off the top $rankmax list.</i><br>
_EOF_
	print $html_foot;
}

sub mania {
	print $html_head;
	print<<"_EOF_";
This page is a system explanation page for heavy breeders who have played<br>
more than 100 times.<br>
It might be interesting to play knowing the system a little better.<p>

* Parameters for Inheritance<br>
There are seven parameters: HRD, SFT, BRN, NET, FAT, MEN, SEX.<br>
These determine the characteristics of your slime.<br>
The values have a value and a dominance factor, and the value with<br>
a higher dominance factor will be the factor for the status.<br>
Genes with higher parameters tend to be more dominant.<p>

When the dominance factors of the two genes are similar, they will<br>
work against each other.  The resulting value will be the sum of the<br>
wto parameters divided by three -- in other words, the status will go<br> 
down by about 30%.<br>
When breeding with close relatives, there is a high chance that similar
genes go against each other, so the possibility of this interference is
greater.  However, it does not mean that the genes themselves are hurt,
so it be a way to make sure to pass down a trait to future generations.<p>

HRD: Hardness.  How tough the skin is.  Affects HP and STR.<br>
SFT: Softness.  How supple the muscle is.  Affects basically every status.<br>
BRN: Brain.  How smart it is.  Affects DEX.<br>
NET: Neurons and reflexes.  Affects SPD greatly, as well as DEX.<br>
FAT: body fat.  Affects weight and stamina greatly.<br>
MEN: Mentality.  The only parameter that is all good.  Affects stamina.<br>
SEX: self-explanatory.<p>

* Status determination.<br>
These are the formulas used.<p>

weight = (2HRD + 3SFT + BRN + 5FAT) / 11<br>
HP = 10(HRD + SFT + FAT) / 3<br>
STM = 5(FAT + MEN)<br>
STR = (HRD + SFT + 3weight) / 5<br>
DEX = BRN (SFT + NET) / (2weight)
SPD =  (SFT * NET) / weight<br>
STMusage = (3weight + BRN + NET + SEX) / 6<br>
SeedFactor = 100SEX / STMusage<p>

SeedFactor/10 (round down) is the initial seed count.<br>
Each time someone plays a round, the seed creation guage is filled with<br> 
the SeedFactor value, and when the guage fills, one extra seed will become<br> 
available.<p>

* Battle engine.<br>
There is a speed guage that goes up by the value of SPD per turn, and the<br>
slime will attack when this is full.<br>
The basic random number (RN) is below (your DEX + opponent SPD).<br>
Hit lands when RN &lt; your DEX<br>
Damage given = your STR ( 1 - [RN / your DEX] ^2)<br>
STM factor = 0.4 + 0.6 (1 - [1 - STM % left] ^2)<br>
The STM factor will be involved in hit landing, damage given, and SPD values.<br>
All random values use the same RN.<br>
The closer RN is to zero, you can give a larger wound and more damage; 
the closer RN is to your DEX value, the wound is smaller and less damage.<br>
The damage graph is based on [y = 1 - x^2].<p>

* STM depletion rate<br>
When you attack: your STMusage.<br>
When you receive an attack: [1.25(opponent STMusage)(1-[RN/your DEX]^2)] + (opponent STMusage / 4)<br>
When you evade an attack: opponent STMusage / 4.<br>
When you have a high STMusage, your overall status is large, so it pressures the opponent.<br>
At most, you can give damage equal to about 1.5 times your STMusage, and even if you miss,<br>
you still will make their STM go down by one fourth of your STMusage.<br>
The larger the damage, the more STM will be used.<br>
The STMusage is dependent on the STM factor; when speed goes down, less stamina is used.<p>


* Genes that determine appearance<br>
There are 3 sets of digital genes (0 or 1), with three types each, for a total of 9.<br>
If a set is 000000 or 111111, there is a chance that it will mutate the other way<br>
(000000 to 111111, and vice versa).<br>
--Color--<br>
red, gren, blue. (11=FF, 10=7F, 00=00)<br>
--Mutation switch--<br>
A mutation occurs at 111111.<br>
Furthermore, this switch assists in determining the color.<br>
When there is a 10 in this switch, it dampens the color gene effects by changing (in<br>
the corresponding area for RGB) from FF to BF, and from 00 to 3F.<br>
--Mutation type determinant--<br>
This only has meaning when the mutation switch is 111111.<br>
Based on the variations, many different mutants can be born.<p>


* Why young slimes can be strong.<br>
The genes carried by Adam and Eve are less dominant compred to the genes at<br>
the bleeding edge of technology.<br>
Therefore, it has a habit of strengthening the mate's genes.<br>
Even if your own genes are weak, most of the traits that will come out will be<br>
from the mate's genes, so even the first slime will end up strong.<br>
However, it is best to avoid inbreeding between Adam and Eve.<br>
If two genes from the early states are met, there is no way to bring the<br>
other out, and an extremely weak slime will result.<p>
<BR>
So, do you understand how it works now?<BR>
Please continue to enjoy Slime Breeder.<BR>
<HR>
<CENTER>
[<A HREF="$backurl" target="_top">$backtitle</A>][<A HREF="$backurl2" target="_top">$backtitle2</A>][<A HREF="$backurl3" target="_top">$backtitle3</A>][<A HREF="$cginame?mode=rank">Ranking</A>][<A HREF="$cginame?mode=title" target="top">Title</A>]<BR>
</CENTER>
_EOF_
	print $html_foot;
}
